<?php
/***************************************************************************
 *
 *  Author: Dennis 'Kapsonfire' Kaspar
 *  Website: http://www.pokecom.eu
 *	Mail: kapsonfire-at-gmx-dot-de
 *
 ***************************************************************************/
 
 /****************************************************************************
	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
****************************************************************************/
$plugins->add_hook('admin_forum_management_begin','kaps_FABR_admin_forum_management_begin');
$plugins->add_hook('forum_permissions_start','kaps_FABR_forum_pemissions_start'); //deny access to forums/threads

if(!defined("IN_MYBB"))
{
	die("Outside of MyBB");
}

if(!defined("PLUGINLIBRARY"))
{
    define("PLUGINLIBRARY", MYBB_ROOT."inc/plugins/pluginlibrary.php");
}


function kapsForumAccessByRep_info()
{
	return array(
		"name"		    => "Forum Access by Reputation",
		"description"	=> "Restrict access to forum by reputation",
		"website"		=> "http://mods.mybb.com",
		"author"		=> "Kapsonfire",
		"authorsite"	=> "http://www.pokecom.eu",
		"version"		=> "0.1",
		"guid"		    => "a897a335d61251cc8ca742259265a6c1",
		"compatibility" => "16*"
	);
}



function kapsForumAccessByRep_is_installed()
{
	global $db;
	return $db->field_exists('kaps_accessbyrep','forums');
}

function kapsForumAccessByRep_install()
{

	if(!file_exists(PLUGINLIBRARY))
    {
        flash_message('Pluginlibrary must be installed', "error");
        admin_redirect("index.php?module=config-plugins");
    }

    global $PL;
    $PL or require_once(PLUGINLIBRARY);

    if($PL->version < 4)
    {
        flash_message('Pluginlibrary is to old. Need v4 or higher', "error");
        admin_redirect("index.php?module=config-plugins");
    }
	
	 $news = '
			if($fid != 0)
			{
				global $plugins;
				$back = $fid;
				$plugins->run_hooks("forum_permissions_start",&$back);
				if($back=="false")
				{
					$perm[\'canview\']=0;
					return $perm;
				}
			}
			';
        // forums
        $edits[] = array(
            'search' => array('function fetch_forum_permissions(','{'),
            'after' => array($news)
			);
	  $PL->edit_core('kaps_farb', 'inc/functions.php', $edits, true);
       
	
	
	
	
	global $db;
	$db->query("ALTER TABLE ".TABLE_PREFIX."forums ADD  `kaps_accessbyrep` INT NOT NULL");
}

function kapsForumAccessByRep_uninstall()
{
	global $db;
	global $PL;
    $PL or require_once PLUGINLIBRARY;

	$PL->edit_core('kaps_farb', 'inc/functions.php', array(), true);
	$db->query("ALTER TABLE ".TABLE_PREFIX."forums DROP  `kaps_accessbyrep`");
}


function kaps_FABR_forum_pemissions_start($fid)
{
	global $db,$mybb;
	$uid = $mybb->user['uid'];
	if($fid==0)return;
	$query = $db->simple_select("forums", '*', "fid='".$fid."'");//kaps_accessbyrep
	$forum_data = $db->fetch_array($query);
	$query = $db->simple_select("users", '*', "uid='".$uid."'");//reputation
	$fuser= $db->fetch_array($query);
	if($forum_data['kaps_accessbyrep']>$fuser['reputation'])
	return 'false';	
	return 'true';

	
	

}

function kaps_FABR_admin_forum_management_begin()
{
	global $sub_tabs,$mybb;
	if(isset($mybb->input['fid']))
	{
		global $lang;
		$sub_tabs['view_forum'] = array(
			'title' => $lang->view_forum,
			'link' => "index.php?module=forum-management&amp;fid=".$mybb->input['fid'],
			'description' => $lang->view_forum_desc
		);
	
		$sub_tabs['add_child_forum'] = array(
			'title' => $lang->add_child_forum,
			'link' => "index.php?module=forum-management&amp;action=add&amp;pid=".$mybb->input['fid'],
			'description' => $lang->add_child_forum_desc
		);
		
		$sub_tabs['edit_forum_settings'] = array(
			'title' => $lang->edit_forum_settings,
			'link' => "index.php?module=forum-management&amp;action=edit&amp;fid=".$mybb->input['fid'],
			'description' => $lang->edit_forum_settings_desc
		);
	
		$sub_tabs['copy_forum'] = array(
			'title' => $lang->copy_forum,
			'link' => "index.php?module=forum-management&amp;action=copy&amp;fid=".$mybb->input['fid'],
			'description' => $lang->copy_forum_desc
		);
	
		$sub_tabs['kaps_fabr'] = array(
				'title' => 'Access by reputation',
				'link' => "index.php?module=forum-management&amp;action=kaps_fabr&amp;fid=".$mybb->input['fid'],
				'description' => ''
			);
	
	
		global $page,$db;
		
	
		if($mybb->input['action'] == "kaps_fabr")
		{
		
				if(isset($_POST['kaps_fabr']))
				{
					if(is_numeric($_POST['kaps_fabr']))
					{
						$minifabr = (int)$_POST['kaps_fabr'];
						$fid = (int)$mybb->input['fid'];
						flash_message('Reputation settings saved.', 'success');
						$db->query("UPDATE ".TABLE_PREFIX."forums SET `kaps_accessbyrep` = {$minifabr} WHERE `fid` = {$fid}");
					}
					else
					{
						flash_message('Reputation minimum must be digit.', 'error');
					}
					//admin_redirect("index.php?module=forum-management&amp;action=kaps_fabr&amp;fid=".$mybb->input['fid']);
				}
				$query = $db->simple_select("forums", '*', "fid='".intval($mybb->input['fid'])."'");
				$forum_data = $db->fetch_array($query);
				$page->add_breadcrumb_item('Access by reputation');
				$page->output_header('Access by reputation');	
				$page->output_nav_tabs($sub_tabs, 'kaps_fabr');
				$form = new Form("index.php?module=forum-management&amp;action=kaps_fabr&amp;fid=".$mybb->input['fid'], "post");
				$form_container = new FormContainer('Access by reputation');
				$form_container->output_row('Access by reputation', "Define the minimum reputation to access a forum", $form->generate_text_box('kaps_fabr', $forum_data['kaps_accessbyrep'], array('id' => 'kaps_fabr')), 'kaps_fabr');
				$form_container->end();
				$buttons[] = $form->generate_submit_button('save');
				$form->output_submit_wrapper($buttons);
				$form->end();
				$page->output_footer();	
				
			
				
				
				
		
			
		}
	}
}


